SystemOrganization addCategory: #'MC2-Smalltalk'!

MDElement subclass: #MDClassAwareElement
	instanceVariableNames: 'theClassName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Smalltalk'!

!MDClassAwareElement class methodsFor: 'instance creation' stamp: 'dc 6/14/2007 05:39'!
className: aSymbol
	^ self new
		setClassName: aSymbol;
		yourself! !

!MDClassAwareElement methodsFor: 'comparing' stamp: 'dc 6/14/2007 05:29'!
= other
	^ (self species = other species)
		and: [self theClassName = other theClassName]! !

!MDClassAwareElement methodsFor: 'accessing' stamp: 'cwp 5/26/2008 21:50'!
domain
	^ #smalltalk! !

!MDClassAwareElement methodsFor: 'comparing' stamp: 'dc 6/14/2007 05:29'!
hash
	^ theClassName hash! !

!MDClassAwareElement methodsFor: 'printing' stamp: 'cwp 10/22/2008 21:42'!
printStdIdOn: aStream with: aString
	aStream
		nextPutAll: self theClassName;
		nextPutAll: ': ';
		nextPutAll: aString;
		nextPutAll: ' ''';
		nextPutAll: self name;
		nextPut: $'! !

!MDClassAwareElement methodsFor: 'initialize-release' stamp: 'dc 6/14/2007 05:30'!
setClassName: aSymbol 
	theClassName := aSymbol! !

!MDClassAwareElement methodsFor: 'accessing' stamp: 'dc 6/14/2007 05:30'!
theClassName
	^ theClassName! !

MDClassAwareElement subclass: #MDClassAwareNamedElement
	instanceVariableNames: 'name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Smalltalk'!

!MDClassAwareNamedElement class methodsFor: 'intance creation' stamp: 'dc 6/14/2007 05:42'!
className: aSymbol name: aString
	^ self new
		setClassName: aSymbol name: aString;
		yourself! !

!MDClassAwareNamedElement methodsFor: 'comparing' stamp: 'dc 6/14/2007 05:43'!
= other
	^ super = other
		and: [self name = other name]! !

!MDClassAwareNamedElement methodsFor: 'comparing' stamp: 'dc 6/14/2007 05:43'!
hash
	^ super hash bitXor: name hash! !

!MDClassAwareNamedElement methodsFor: 'accessing' stamp: 'dc 6/14/2007 05:43'!
name
	^ name! !

!MDClassAwareNamedElement methodsFor: 'initialize-release' stamp: 'dc 6/14/2007 05:44'!
setClassName: aSymbol name: aString
	theClassName := aSymbol.
	name := aString! !

MDClassAwareNamedElement subclass: #MDClassInstVarElement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Smalltalk'!

!MDClassInstVarElement methodsFor: 'dispatching' stamp: 'cwp 10/16/2009 22:27'!
handleWith: anObject
	^ anObject handleClassInstVar: self! !

!MDClassInstVarElement methodsFor: 'printing' stamp: 'cwp 10/22/2008 21:47'!
printOn: aStream
	self printStdIdOn: aStream with: 	'class instance variable'! !

MDClassAwareNamedElement subclass: #MDClassVarElement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Smalltalk'!

!MDClassVarElement methodsFor: 'dispatching' stamp: 'cwp 10/16/2009 22:27'!
handleWith: anObject
	^ anObject handleClassVar: self! !

!MDClassVarElement methodsFor: 'printing' stamp: 'cwp 10/22/2008 21:45'!
printOn: aStream
	^ self printStdIdOn: aStream with: 'class variable'! !

MDClassAwareNamedElement subclass: #MDInstVarElement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Smalltalk'!

!MDInstVarElement methodsFor: 'dispatching' stamp: 'cwp 10/16/2009 22:27'!
handleWith: anObject
	^ anObject handleInstVar: self! !

!MDInstVarElement methodsFor: 'printing' stamp: 'cwp 10/22/2008 21:47'!
printOn: aStream
	^ self printStdIdOn: aStream with: 'instance variable'! !

MDClassAwareNamedElement subclass: #MDPoolImportElement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Smalltalk'!

!MDPoolImportElement class methodsFor: 'instance creation' stamp: 'cwp 4/28/2008 22:04'!
className: classNameSymbol name: poolNameSymbol 
	^ self basicNew 
		setClassName: classNameSymbol
		name: poolNameSymbol! !

!MDPoolImportElement methodsFor: 'dispatching' stamp: 'cwp 10/16/2009 22:28'!
handleWith: anObject
	^ anObject handlePoolImport: self! !

!MDPoolImportElement methodsFor: 'printing' stamp: 'cwp 10/22/2008 21:48'!
printOn: aStream
	self printStdIdOn: aStream with: 'pool import'! !

MDClassAwareElement subclass: #MDClassCommentElement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Smalltalk'!

!MDClassCommentElement commentStamp: 'cwp 5/7/2006 22:32' prior: 0!
I am a reference to the comment of a particular class.

theClassName - the name of the class to whose comment I refer

!

!MDClassCommentElement methodsFor: 'dispatching' stamp: 'cwp 10/16/2009 22:28'!
handleWith: anObject
	^ anObject handleClassComment: self! !

!MDClassCommentElement methodsFor: 'printing' stamp: 'cwp 10/22/2008 21:54'!
printOn: aStream
	aStream
		nextPutAll: theClassName;
		space;
		nextPutAll: 'comment'! !

MDClassAwareElement subclass: #MDClassElement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Smalltalk'!

!MDClassElement commentStamp: 'cwp 5/7/2006 22:34' prior: 0!
I am a reference to a class.

theClassName - the name of the class
!

!MDClassElement methodsFor: 'dispatching' stamp: 'cwp 10/16/2009 22:28'!
handleWith: anObject
	^ anObject handleClass: self! !

!MDClassElement methodsFor: 'printing' stamp: 'cwp 10/22/2008 21:52'!
printOn: aStream
	aStream nextPutAll: theClassName! !

MDClassAwareElement subclass: #MDMethodElement
	instanceVariableNames: 'selector classIsMeta'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Smalltalk'!

!MDMethodElement class methodsFor: 'instance creation' stamp: 'dc 6/14/2007 05:50'!
className: aString selector: aSymbol 
	^ self className: aString selector: aSymbol classIsMeta: false! !

!MDMethodElement class methodsFor: 'instance creation' stamp: 'dc 6/14/2007 05:50'!
className: aString selector: aSymbol classIsMeta: aBoolean
	^ self new
		setClassName: aString selector: aSymbol classIsMeta: aBoolean;
		yourself! !

!MDMethodElement methodsFor: 'comparing' stamp: 'cwp 3/16/2008 21:42'!
= other 
	^ super = other
		and: [self selector = other selector]
		and: [self classIsMeta = other classIsMeta]! !

!MDMethodElement methodsFor: 'accessing' stamp: 'cwp 2/12/2005 15:25'!
classIsMeta
	^ classIsMeta! !

!MDMethodElement methodsFor: 'dispatching' stamp: 'cwp 10/16/2009 22:29'!
handleWith: anObject
	^ anObject handleMethod: self! !

!MDMethodElement methodsFor: 'comparing' stamp: 'cwp 3/16/2008 21:59'!
hash
	^ self printString hash! !

!MDMethodElement methodsFor: 'accessing' stamp: 'cwp 8/28/2005 17:15'!
name
	^ selector! !

!MDMethodElement methodsFor: 'printing' stamp: 'cwp 10/22/2008 21:59'!
printOn: aStream
	aStream nextPutAll: self theClassName.
	self classIsMeta ifTrue: [aStream nextPutAll: ' class'].
	aStream 
		nextPutAll: '>>';
		nextPutAll: self selector! !

!MDMethodElement methodsFor: 'accessing' stamp: 'avi 11/28/2004 16:26'!
selector
	^ selector! !

!MDMethodElement methodsFor: 'initialize-release' stamp: 'cwp 2/12/2005 15:15'!
setClassName: aString selector: aSymbol classIsMeta: aBoolean
	theClassName := aString.
	selector := aSymbol.
	classIsMeta := aBoolean! !

MDSliceInclusionHandler subclass: #MDSmalltalkInclusionHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Smalltalk'!

!MDSmalltalkInclusionHandler methodsFor: 'handling' stamp: 'cwp 10/16/2009 17:04'!
handleClass: aClassElement 
	^ slice includesClass: aClassElement! !

!MDSmalltalkInclusionHandler methodsFor: 'handling' stamp: 'cwp 10/16/2009 20:35'!
handleClassComment: anElement
	^ slice includesClassComment: anElement! !

!MDSmalltalkInclusionHandler methodsFor: 'handling' stamp: 'cwp 10/16/2009 20:36'!
handleClassInstVar: aClassElement 
	^ slice includesClassInstVar: aClassElement! !

!MDSmalltalkInclusionHandler methodsFor: 'handling' stamp: 'cwp 10/16/2009 20:36'!
handleClassVar: aClassElement 
	^ slice includesClassVar: aClassElement! !

!MDSmalltalkInclusionHandler methodsFor: 'handling' stamp: 'cwp 10/16/2009 20:37'!
handleInstVar: anElement 
	^ slice includesInstVar: anElement! !

!MDSmalltalkInclusionHandler methodsFor: 'handling' stamp: 'cwp 10/16/2009 17:03'!
handleMethod: aMethodElement 
	^ slice includesMethod: aMethodElement! !

!MDSmalltalkInclusionHandler methodsFor: 'handling' stamp: 'cwp 10/16/2009 21:16'!
handlePoolImport: anElement
	^ slice includesPoolImport: anElement! !
